//***************************************************************************
//
//                         Uses LARGE memory model
//
//***************************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <dos.h>
#include <dir.h>
#include <direct.h>
#include <fcntl.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <sys\stat.h>
#include "dram.h"
#include "futil.h"

extern void _fastcall ccitt_crc32_calc(unsigned);
int   pos(char*,char*);
void  delete_ch(char*,int,int);

int ems_flag                    = 0;
unsigned _ovrbuffer             = 0;
extern unsigned _stklen         = 24576;

static int  lgth_date_fmt       = 0;
static int  verify_exists       = 0;
static int  directory_merge     = 0;
static int  unlink_after_cpy    = 0;
static int  big_sort            = 0;
static int  biggest_record      = 80;
static char mrg_src_dir[128]    = "";
static char mrg_src_bbs[128]    = "";
static char mrg_dest_dir[128]   = "";
static char mrg_work_dir[128]   = "";
static int tab_stop[82];
char gtpath[128]   = "";
char bbs_path[128] = "";
char lan_path[128] = "";

void wf_printf(char *fmt,...)
{
    va_list argptr;

    va_start(argptr,fmt);
    vprintf(fmt,argptr);
    va_end(argptr);
}

static struct bbs_list {
    char bbs_name[28];
    struct bbs_list *next_bbs_name;
};
static struct bbs_list *bbs_list_root  = NULL;
static struct bbs_list *bbs_list_prior = NULL;
static struct bbs_list *bbs_list_curr  = NULL;

void add_bbs_name(char *s)
{
    struct bbs_list *p;

    p = (struct bbs_list *) malloc(sizeof(struct bbs_list));
    strncpy(p->bbs_name,s,27);
    p->bbs_name[27] = 0;
    p->next_bbs_name = NULL;
    if (bbs_list_root == NULL)
        bbs_list_root = p;
    if (bbs_list_prior != NULL)
        bbs_list_prior->next_bbs_name = p;
    bbs_list_prior = p;
}

void free_bbs_table(void)
{
    struct bbs_list *p;
    struct bbs_list *np;

    p = bbs_list_root;
    while (p != NULL) {
       np = p->next_bbs_name;
       free(p);
       p = np;
    }
}

struct ft_table {
    int ft_line_cnt;
    char *ft_line[11];
};
static int ft_cnt       = 0;
#define MAX_FILE_TABLE  1480
static struct ft_table *ft_ptr[MAX_FILE_TABLE];

char *detab(char *os,char *s)
{
    int j, k, ch;

    j = 0;
    for (k=0; (ch = s[k]); k++) {
        if (ch == '\t') {
            do {
                os[j++] = ' ';
            } while (!tab_stop[j]);
        }
        else {
            os[j++] = ch;
        }
    }
    os[j] = 0;
    return(os);
}

int DeBlank(char *s)
{
    int i, j, k, ch;

    j = 0;
    while (ch = s[j]) {
        if (ch == ' ') {
            k = j + 1;
            if (s[k++] == ' ') {
                i = k;
                while (s[k] == ' ')
                    k++;
                delete_ch(s,i,(k-i+1));
            }
        }
        j++;
    }
    i = j - 1;
    if (s[i] == '\\') {
        j = i;
        s[j] = 0;
    }
    return(j);
}

void write_fn_table(FILE *text_out,FILE *allfiles,char *files_path)
{
    char s[528];
    int j, k, nbr, slen, doit;

    for (j=0; j<ft_cnt; j++) {
        if (ft_ptr[j]) {
            doit = 1;
            if (verify_exists) {
                if (!strcmp("NOT FOUND",ft_ptr[j]->ft_line[0]))
                    doit = 0;
            }
            if (doit) {
                nbr = ft_ptr[j]->ft_line_cnt;
                for (k=0; k<nbr; k++) {
                    if (ft_ptr[j]->ft_line[k]) {
                        fprintf(text_out,"%s\n",detab(s,ft_ptr[j]->ft_line[k]));
                        if (!k) {
                            if ((big_sort)&&(allfiles!=NULL)) {
                                strcat(s," ");
                                strcat(s,files_path);
                                slen = DeBlank(s) + 1;
                                if (slen > biggest_record)
                                    biggest_record = slen;
                                fprintf(allfiles,"%s\n",s);
                            }
                        }
                    }
                }
            }
        }
    }
}

void sort_fn_table(void)
{
    int j, k, low_end, high_end, hit;
    struct ft_table *hold_ptr;

    low_end  = 0;
    high_end = ft_cnt - 1;
    if (high_end < 1)
        goto ExitSort;
    printf("\n\nSorting...");
    do {
        hit = 0;
        for (j=low_end; j<high_end; j++) {
            k = j + 1;
            if (strcmp(ft_ptr[j]->ft_line[0],ft_ptr[k]->ft_line[0]) > 0) {
                hit = 1;
                hold_ptr  = ft_ptr[j];
                ft_ptr[j] = ft_ptr[k];
                ft_ptr[k] = hold_ptr;
            }
        }
        high_end--;
        for (k=high_end; k>low_end; k--) {
            j = k - 1;
            if (strcmp(ft_ptr[j]->ft_line[0],ft_ptr[k]->ft_line[0]) > 0) {
                hit = 1;
                hold_ptr  = ft_ptr[j];
                ft_ptr[j] = ft_ptr[k];
                ft_ptr[k] = hold_ptr;
            }
        }
        low_end++;
    } while (hit);
ExitSort:
    return;
}

void init_fn_table(void)
{
    int j, k, nbr;

    for (j=0; j<ft_cnt; j++) {
        if (ft_ptr[j]) {
            nbr = ft_ptr[j]->ft_line_cnt;
            for (k=0; k<nbr; k++) {
                if (ft_ptr[j]->ft_line[k])
                    free(ft_ptr[j]->ft_line[k]);
            }
            free(ft_ptr[j]);
            ft_ptr[j] = NULL;
        }
    }
    ft_cnt = 0;
}

int chg_dir(char *p)
{
    char temp[128];
    char wrk[128];
    int j, deslash_it, drive;

    if (! p[0])
	return(0);
    getcwd(temp,126);
    strcpy(wrk,p);
    strupr(wrk);
    deslash_it = 1;
    if (wrk[1] == ':') {
        drive = wrk[0] - 'A' + 1;
	_chdrive(drive);
	if (! wrk[2]) {
	    strcat(wrk,"\\");
	    deslash_it = 0;
	}
    }
    if (deslash_it) {
        if ((j = strlen(wrk) - 1) > 0)
	    if (wrk[j] == '\\')
	        wrk[j] = 0;
    }
    if (chdir(wrk)) {
	chg_dir(temp);
	return(-1);
    }
    return(0);
}

int is_white(int ch)
{
    int j;

    j = ch & 0x00FF;
    if ((j==' ')||(j=='\t')||(j==0x00FF))
        return(1);
    return(0);
}

char *select_path(char *s)
{
    if (lan_path[0])
	strcpy(s,lan_path);
    else
	strcpy(s,gtpath);
    return(s);
}

unsigned fn_hash(char *fn)
{
    int j;

    crc_reg_lo =
      crc_reg_hi = 0xFFFF;
    for (j=0; ((fn[j])&&(fn[j]!='.')); j++)
        ccitt_crc32_calc(fn[j]);
    for (j=0; j<4; j++)
        ccitt_crc32_calc(0);
    return( (crc_reg_hi ^ crc_reg_lo) % 5 );
}

int lookup_files_db(
    char *fname,
    char *fpath,
    long *bsize,
    int *offline
    )
{
    char extents[128], hname[128];
    DRAM far *fcb;
    char db_path[128];
    unsigned db_cnt;
    FILES_RECORD far *p;
    char fn_work[128];
    int res, k, mlen, wh_period, wx;

    *bsize =
      *offline =
        wh_period =
	  res = 0;
    fcb = allocate_fcb();
    p = (FILES_RECORD far *) fcb->user_rec;
    fcb->dat_recsize = sizeof(FILES_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    select_path(db_path);
    strcpy(fcb->dram_path,db_path);
    dram_slasher(fcb);
    strupr(fname);
    db_cnt = fn_hash(fname);
    sprintf(fn_work,"FILES_%u",db_cnt);
    strcpy(fcb->dram_fname,fn_work);
    if (dram(OPEN,fcb)) {
        printf("\n**ERROR: database open failed %s",fn_work);
	goto NotFound;
    }
    fcb->binary_key = 0;
    strcpy(fcb->string_key,fname);
    if (dram(READ,fcb)) {
	wh_period = pos(".",fname);
	if (wh_period > 0)
	    fname[wh_period] = 0;
	strcpy(hname,fname);
	strcpy(extents,".ARJ .ZIP .LZH .GIF .ARC .EXE .ZOO");
        mlen = strlen(extents) + 1;
        for (k = 4; k<mlen; k += 5) {
            extents[k] = 0;
	    wx = k - 4;
	    strcpy(fcb->string_key,hname);
	    strcat(fcb->string_key,&extents[wx]);
            fcb->binary_key = 0;
	    if (!dram(READ,fcb))
		goto FileFound;
        }
	dram(CLOSE,fcb);
NotFound:
        res = 2;
        goto LookupExit;
    }
FileFound:
    *offline = p->files_offline;
    strcpy(fname,p->files_name);
    strcpy(fpath,p->files_path);
    *bsize = p->files_size;
    res = 1;
    dram(CLOSE,fcb);
LookupExit:
    release_fcb(fcb);
    return(res);
}

int redo_line_format(char *s,char *files_path)
{
    int j, k, loop_cnt, result, ch, rescode;
    char fsize_txt[32];
    struct stat sb;
    struct tm *tm_ptr;
    char filename[256], ws[300], fullpath[256], ws_out[300];

    rescode = 1;
    filename[0] = 0;
    strcpy(ws,s);
    for (j=0; (ch = filename[j] = ws[j]); j++) {
        if (is_white(ch)) {
            filename[j] = 0;
            break;
        }
    }
    if ((!filename[0]) || (!ch))
        return(rescode);
    for (k=j; (ch = ws[k]); k++) {
        if (!is_white(ch))
            goto Y0;
    }
NoDesc:
    ws[0] = 0;
    k = 0;
    goto BuildNewLine;
Y0:
    loop_cnt = 0;
    while (loop_cnt<4) {
        if ((ch<'0')||(ch>'9'))
            if (ch!='-')
                goto BuildNewLine;
        j = k++;
        ch = toupper(ws[k]);
        if (!is_white(ch)) {
            if (ch!=',')
                if ((ch<'0')||(ch>'9'))
                    goto BuildNewLine;
        }
        for (k=j; (ch = ws[k]); k++) {
            if (is_white(ch))
                goto X0;
        }
        goto NoDesc;
X0:
        j = k;
        for (k=j; (ch = ws[k]); k++) {
            if (!is_white(ch))
                goto X1;
        }
        goto NoDesc;
X1:
        loop_cnt++;
    }
    goto NoDesc;
BuildNewLine:
    if (files_path != NULL) {
        strcpy(fullpath,files_path);
        strcat(fullpath,filename);
        rescode = 0;
        result = stat(fullpath,&sb);
        if (!result) {
            rescode = 1;
            tm_ptr = gmtime(&sb.st_atime);
            if (sb.st_size == 0)
                sprintf(fsize_txt,"%-7s","");
            else
                sprintf(fsize_txt,"%7ld",sb.st_size);
            sprintf(ws_out,"%-12s %s %2d%02d%02d %s",
                filename,fsize_txt,
                tm_ptr->tm_year,(tm_ptr->tm_mon+1),tm_ptr->tm_mday,
                &ws[k]);
            goto RedoExit;
        }
        return(rescode);
    }
    sprintf(ws_out,"%-12s  %s",filename,&ws[k]);
RedoExit:
    strcpy(s,ws_out);
    return(rescode);
}

void add_fn_table(char *s,char *files_path)
{
    int amt, k, file_exists;
    char *p;

    if (ft_cnt >= MAX_FILE_TABLE) {
        printf("\nTable size exceeded, it will hold %d files!",MAX_FILE_TABLE);
        exit(1);
    }
    file_exists = 1;
    ft_ptr[ft_cnt] = (struct ft_table *) malloc(sizeof(struct ft_table));
    ft_ptr[ft_cnt]->ft_line_cnt = 1;
    if (lgth_date_fmt)
        file_exists = redo_line_format(s,files_path);
    if ((verify_exists) && (!file_exists))
        strcpy(s,"NOT FOUND");
    amt = strlen(s);
    if (amt < 80)
        amt = 80;
    p = (char *) malloc(amt+8);
    strcpy(p,s);
    ft_ptr[ft_cnt]->ft_line[0] = p;
    for (k=1; k<11; k++)
        ft_ptr[ft_cnt]->ft_line[k] = NULL;
    ft_cnt++;
}

void add_fn_ds_table(char *s)
{
    char *p;
    int amt, j, k;

    k = ft_cnt - 1;
    if (k < 0)
        return;
    j = ft_ptr[k]->ft_line_cnt;
    if (j > 10)
        return;
    ft_ptr[k]->ft_line_cnt = j + 1;
    amt = strlen(s) + 4;
    p = (char *) malloc(amt);
    strcpy(p,s);
    ft_ptr[k]->ft_line[j] = p;
}

int pos(char *searchtag,char *fulltag)
{
    int i,j,lensrch;

    lensrch = strlen(searchtag);
    if (lensrch) {
	j = strlen(fulltag) - lensrch + 1;
	for (i = 0; i < j; i++) {
	    if (! strncmp(searchtag,&fulltag[i],lensrch))
		return(i);
	}
	return(-1);
    }
    return(0);
}

int strip_nl(char *s,int imax)
{
    int j, lmax;

    lmax = imax - 1;
    j = 0;
    while ((s[j]) && (s[j] != '\n') && (s[j] != '\r') && (j < lmax))
	j++;
    s[j] = 0;
    return(j);
}

int is_filename(char *fn)
{
    int k, pp, uc, lc, ch;

    ch = fn[0];
    if ((ch <= ' ')||(ch > 'z'))
	return(0);
    if ((ch=='=')||(ch=='-')||(ch=='_')) {
	if ((fn[1]==ch)&&(fn[2]==ch))
	    return(0);
    }
    lc =
      uc =
	pp =
	  k = 0;
    while (ch = (fn[k++] & 0x00ff)) {
	if (is_white(ch))
	    goto CheckMixedCase;
	if ((ch==0x00e0)||(ch==0x00e1))
	    continue;
	if ((ch < ' ')||(ch > 'z'))
	    return(0);
	if ((ch==':') ||
	     (ch==';') ||
	      (ch=='/') ||
	       (ch=='\\') ||
	        (ch=='[') ||
	         (ch==']') ||
	          (ch=='>') ||
	           (ch=='<') ||
	            (ch=='*')) {
	    return(0);
        }
	if (ch == '.') {
	    pp++;
	    continue;
	}
	if ((ch >= 'A')&&(ch <= 'Z')) {
	    uc = 1;
	    continue;
	}
	if ((ch >= 'a')&&(ch <= 'z')) {
	    lc = 1;
	    continue;
	}
    }
CheckMixedCase:
    if ((uc)&&(lc))
	return(0);
    if (--k > 12) {
	return(0);
    }
    if (pp > 1)
	return(0);
    return(1);
}

int is_continuation(char *s)
{
    int j, ch;

    for (j=0; (ch = s[j]); j++) {
        if (ch=='|')
            return(1);
        if (!is_white(ch))
            return(0);
    }
    return(0);
}

void delete_ch(char *s,int start,int size)
{
    unsigned j, m, k;

    k = strlen(s);
    if (k) {
	j = start - 1;
	s[j] = 0;
	m = j + size;
	if (m < k)
	    strcpy(&s[j],&s[m]);
    }
}

void extract_path(char *os,char *s)
{
    int j;

    strcpy(os,s);
    j = strlen(s);
    while (j >= 0) {
        if ((s[j]=='\\')||(s[j]=='/')) {
            os[++j] = 0;
            return;
        }
        j--;
    }
    os[0] = 0;
}

void process_pathname(char *p)
{
    int j;

    if (p[0]) {
	strupr(p);
	j = strlen(p) - 1;
	if (p[j] == '\n')
	    p[j--] = 0;
	if (p[j] == '\r')
	    p[j--] = 0;
	if (p[j++] != '\\') {
	    p[j++] = '\\';
	    p[j] = 0;
	}
    }
}

int fgets_p(char *s,int imax,FILE *f)
{
    char *p;

    p = fgets(s,(imax - 4),f);
    if ((p==NULL)||(s[0]==0x1A)) {
        s[0] = 0;
        return(-1);
    }
    return( strip_nl(s,imax) );
}

struct fdir {
    char   fd_path[80];
    char   fd_bbs[80];
    struct fdir *next_fd;
};
static int fd_cnt           = 0;
struct fdir *first_fd       = NULL;
struct fdir *last_fd        = NULL;

void init_fd_table(void)
{
    struct fdir *cp;
    struct fdir *np;

    fd_cnt = 0;
    cp = first_fd;
    while (cp != NULL) {
        np = cp->next_fd;
        free(cp);
        cp = np;
    }
    first_fd = NULL;
    last_fd  = NULL;
}

int load_fd_table(char *p)
{
    struct fdir *cp;
    char curr_path[256];
    char curr_bbs[128];
    int found_path, alloc_amt, ch, j, k, looping;

    ch = p[0];
    while ((ch) && (!is_white(ch))) {
	delete_ch(p,1,1);
	ch = p[0];
    }
    if (!ch)
	return(0);
    while ((ch) && (is_white(ch))) {
	delete_ch(p,1,1);
	ch = p[0];
    }
    if (!ch)
	return(0);
    k = 0;
    while ((ch) && (!is_white(ch)))
	ch = p[++k];
    if (ch)
	p[k] = 0;
    do {
        looping = 0;
        switch (p[0]) {
        case '':
            looping = 1;
            delete_ch(p,1,1);
            break;
        case '(':
            looping = 1;
            delete_ch(p,1,3);
            break;
        }
    } while (looping);
    curr_bbs[0] = 0;
    strncpy(curr_path,p,256);
    curr_path[255] = 0;
    if ((j = pos(",",curr_path)) > 0) {
	curr_path[j] = ';';
	if ((k = pos(",",curr_path)) > 0) {
	    curr_path[k++] = 0;
	    strncpy(curr_bbs,&curr_path[k],80);
            curr_bbs[127] = 0;
	}
	curr_path[j] = 0;
    }
    process_pathname(curr_path);
    if (curr_bbs[0]) {
	strupr(curr_bbs);
	if ((k = pos(",",curr_bbs)) > 0)
	    curr_bbs[k] = 0;
    }
    else {
	sprintf(curr_bbs,"%sFILES.BBS",curr_path);
    }
    cp = first_fd;
    found_path = 0;
    while (cp != NULL) {
	if (!stricmp(cp->fd_path,curr_path)) {
	    found_path = 1;
	    break;
	}
	cp = cp->next_fd;
    }
    if (!found_path) {
	alloc_amt = sizeof(struct fdir) + 4;
	cp = (struct fdir *) malloc(alloc_amt);
	if (first_fd == NULL)
	    first_fd = cp;
	if (cp == NULL)
	    return(1);
	strcpy(cp->fd_path,curr_path);
	strcpy(cp->fd_bbs,curr_bbs);
	cp->next_fd = NULL;
	fd_cnt++;
	if (last_fd != NULL)
	    last_fd->next_fd = cp;
	last_fd = cp;
    }
    return(0);
}

void load_gtdir(char *dir_name)
{
    char wrk[516];
    int ramt, loaderror;
    FILE *text;

    if (dir_name[0] == '@')
        delete_ch(dir_name,1,1);
    if ((text = fopen(dir_name,"rt")) == NULL) {
	printf("\n**ERROR: cannot open \"%s\".\n",dir_name);
        exit(1);
    }
    loaderror =
      ramt =
	fd_cnt = 0;
    while ((ramt >= 0) && (!loaderror)) {
	if ((ramt = fgets_p(wrk,512,text)) > 0) {
	    if ((!is_white(wrk[0]))&&(wrk[0]!='.')) {
	        loaderror = load_fd_table(wrk);
		if (loaderror) {
		    printf("\n**ERROR: GTDIR load error at \"%s\".",wrk);
                    exit(1);
                }
	    }
	}
    }
    fclose(text);
}

static char static_files_path[128];
static int reenter_flag = 0;

void process_files_bbs(
    char *filename_inp,
    char *filename_tmp,
    char *filename_bak,
    char *f_path,
    FILE *allfiles
    )
{
    FILE *text_in;
    FILE *text_out;
    int k, ch;
    char s[528];
    char ws[528];
    char f_inp[128], f_tmp[128], f_bak[128];
    char drive[16], dir[128], name[80], ext[80];

    if (!reenter_flag)
        strcpy(static_files_path,f_path);
    reenter_flag++;
    printf("\nINPUT  : %s",filename_inp);
    printf("\nTEMP   : %s",filename_tmp);
    printf("\nBACKUP : %s\n",filename_bak);
    ft_cnt = 0;
    for (k=0; k<MAX_FILE_TABLE; k++)
        ft_ptr[k] = NULL;
    text_in = fopen(filename_inp,"rt");
    if (text_in == NULL) {
        printf("\n**WARNING: cannot open %s\n",filename_inp);
        reenter_flag--;
        return;
    }
    text_out = fopen(filename_tmp,"wt");
    if (text_out == NULL) {
        fclose(text_in);
        printf("\n**ERROR: cannot create %s",filename_tmp);
        exit(1);
    }
    printf("\nReading: %s",filename_inp);
    while (fgets(s,512,text_in) != NULL) {
        strip_nl(s,512);
        if (s[0] == 6) {                 // Ctrl-F
            if (ft_cnt) {
                sort_fn_table();
                write_fn_table(text_out,allfiles,static_files_path);
                init_fn_table();
            }
            fprintf(text_out,"%s\n",detab(ws,s));
            s[128] = 0;
            strcpy(f_inp,&s[1]);
            strupr(f_inp);
            _splitpath(f_inp,drive,dir,name,ext);
            _makepath(f_tmp,drive,dir,name,".$$$");
            _makepath(f_bak,drive,dir,name,".BAK");
            process_files_bbs(f_inp,f_tmp,f_bak,static_files_path,allfiles);
            goto NextLine;
        }
        if (is_continuation(s)) {
            add_fn_ds_table(s);
            goto NextLine;
        }
        if (is_filename(s)) {
            k = 0;
            while (ch = (s[k] & 0x00FF)) {
                if ((ch==0x00E0)||(ch==0x00E1))
                    goto NextChar;
                if ((ch<=' ')||(ch>'z'))
	            goto StoreLine;
	        if ((ch >= 'a')&&(ch <= 'z'))
  	            s[k] = toupper(ch);
NextChar:
                k++;
            }
StoreLine:
            add_fn_table(s,static_files_path);
            goto NextLine;
        }
        if (ft_cnt) {
            sort_fn_table();
            write_fn_table(text_out,allfiles,static_files_path);
            init_fn_table();
        }
        if (s[0] == ';') {
	    if (!strnicmp(&s[1],"PATH",4)) {
                strcpy(static_files_path,&s[6]);
		process_pathname(static_files_path);
            }
        }
        fprintf(text_out,"%s\n",detab(ws,s));
NextLine:
        ;
    }
    if (ft_cnt) {
        sort_fn_table();
        write_fn_table(text_out,allfiles,static_files_path);
        init_fn_table();
    }
    printf("\n\nWriting: %s\n",filename_tmp);
    fclose(text_out);
    fclose(text_in);
    //**********************************************
    printf("\nCreating backup: %s\n",filename_bak);
    unlink(filename_bak);
    rename(filename_inp,filename_bak);
    text_in = fopen(filename_tmp,"rt");
    if (text_in == NULL) {
        printf("\n**ERROR: cannot open %s",filename_tmp);
        exit(1);
    }
    text_out = fopen(filename_inp,"wt");
    if (text_out == NULL) {
        fclose(text_in);
        printf("\n**ERROR: cannot create %s",filename_inp);
        exit(1);
    }
    printf("\nReading: %s",filename_tmp);
    while (fgets(s,512,text_in) != NULL)
        fputs(s,text_out);
    printf("\n\nWriting: %s\n",filename_inp);
    fclose(text_out);
    fclose(text_in);
    unlink(filename_tmp);
    reenter_flag--;
    return;
}

int name_matches(char *file_name,char *desc)
{
    int result, j, ch;

    result = 0;
    if (desc == NULL)
        goto NameMatchExit;
    for (j=0; (ch = file_name[j]); j++) {
        if (ch != desc[j])
            goto NameMatchExit;
    }
    result = 1;
NameMatchExit:
    return(result);
}

void write_file_desc(char *file_name,FILE *bbs_out)
{
    char s[528];
    int j, k, nbr;

    if (bbs_out == NULL)
        return;
    for (j=0; j<ft_cnt; j++) {
        if (ft_ptr[j]) {
            if (name_matches(file_name,ft_ptr[j]->ft_line[0])) {
                nbr = ft_ptr[j]->ft_line_cnt;
                for (k=0; k<nbr; k++) {
                    if (ft_ptr[j]->ft_line[k])
                        fprintf(bbs_out,"%s\n",detab(s,ft_ptr[j]->ft_line[k]));
                }
                return;
            }
        }
    }
}

void load_file_desc(void)
{
    FILE *text_in;
    int k, ch;
    char s[528];

    ft_cnt = 0;
    for (k=0; k<MAX_FILE_TABLE; k++)
        ft_ptr[k] = NULL;
    text_in = fopen(mrg_src_bbs,"rt");
    if (text_in == NULL) {
        printf("\n**WARNING: cannot open %s\n",mrg_src_bbs);
        return;
    }
    while (fgets(s,512,text_in) != NULL) {
        strip_nl(s,512);
        if (s[0] == 6)
            goto NextLine;
        if (is_continuation(s)) {
            add_fn_ds_table(s);
            goto NextLine;
        }
        if (is_filename(s)) {
            k = 0;
            while (ch = (s[k] & 0x00FF)) {
                if ((ch==0x00E0)||(ch==0x00E1))
                    goto NextChar;
                if ((ch<=' ')||(ch>'z'))
	            goto StoreLine;
	        if ((ch >= 'a')&&(ch <= 'z'))
  	            s[k] = toupper(ch);
NextChar:
                k++;
            }
StoreLine:
            add_fn_table(s,mrg_src_dir);
        }
NextLine:
        ;
    }
    fclose(text_in);
}

struct fnam {
    char file_name[28];
    struct fnam *next_fnam;
};
static struct fnam *fnam_root  = NULL;
static struct fnam *fnam_prior = NULL;

void add_fnam_table(char *s)
{
    struct fnam *p;

    p = (struct fnam *) malloc(sizeof(struct fnam));
    strncpy(p->file_name,s,27);
    p->file_name[27] = 0;
    p->next_fnam = NULL;
    if (fnam_root == NULL)
        fnam_root = p;
    if (fnam_prior != NULL)
        fnam_prior->next_fnam = p;
    fnam_prior = p;
}

void init_fnam_table(void)
{
    struct fnam *p;
    struct fnam *np;

    p = fnam_root;
    while (p != NULL) {
        np = p->next_fnam;
        free(p);
        p = np;
    }
    fnam_root  = NULL;
    fnam_prior = NULL;
}

FILE *db_log              = NULL;
static int  db_log_open   = 0;
static int  FilesMerged   = 0;
static int  FilesSkipped  = 0;
static int  FilesTotal    = 0;
static long BytesMerged   = 0L;
static long MergeStart    = 0L;
static long MergeFin      = 0L;

void close_db_log(void)
{
    if (db_log_open) {
        if (db_log != NULL)
            fclose(db_log);
    }
    db_log_open = 0;
}

void open_db_log(void)
{
    char db_log_name[128];

    if (!db_log_open) {
        strcpy(db_log_name,mrg_work_dir);
        strcat(db_log_name,"DUP.LOG");
        db_log = fopen(db_log_name,"wt");
    }
    db_log_open = 1;
}

void db_logger(char *s)
{
    open_db_log();
    if (db_log != NULL)
        fprintf(db_log,"%s\n",s);
}

void CopyFile(struct fnam *p,char *workdir)
{
    FILE *fout;
    FILE *finp;
    size_t ramt;
    char rbuf[8200];
    char fname_out[128];
    char fname_inp[128];

    strcpy(fname_inp,mrg_src_dir);
    strcat(fname_inp,p->file_name);
    finp = fopen(fname_inp,"rb");
    if (finp == NULL) {
        printf("\n**ERROR: cannot open \"%s\" for input.\n",fname_inp);
        FilesSkipped++;
        return;
    }
    strcpy(fname_out,workdir);
    strcat(fname_out,p->file_name);
    fout = fopen(fname_out,"wb");
    if (fout == NULL) {
        printf("\n**ERROR: cannot open \"%s\" for output.\n",fname_inp);
        fclose(finp);
        FilesSkipped++;
        return;
    }
    FilesMerged++;
    printf("\n   -> %-12s  %3d of %d",
        p->file_name,
          (FilesMerged+FilesSkipped),
            FilesTotal
          );
    while (ramt = fread(rbuf,sizeof(char),8192,finp)) {
        fwrite(rbuf,sizeof(char),ramt,fout);
        BytesMerged += ramt;
    }
    fclose(fout);
    fclose(finp);
}

void MergeFile(struct fnam *p,char *workdir,FILE *bbs_out)
{
    char far *original_dta_address;
    struct find_t ffblk;
    char ws[256];
    char mask[128];
    char lookup_name[128];
    char fpath[128];
    char extension[32];
    int j, offline, lookup_result;
    long bsize;
    unsigned not_found;

    strcpy(mask,mrg_dest_dir);
    strcat(mask,p->file_name);
    j = pos(".",mask);
    if (j > 0) {
        mask[j++] = 0;
        strcpy(extension,&mask[j]);
        strupr(extension);
        if (!strcmp(extension,"BBS"))
            goto MergeExit;
        if (!strcmp(extension,"CBS"))
            goto MergeExit;
        if (!strcmp(extension,"BAK"))
            goto MergeExit;
        if (!strcmp(extension,"DIR"))
            goto MergeExit;
        if (!strcmp(extension,"TXT"))
            goto MergeExit;
        if (!strcmp(extension,"ION"))
            goto MergeExit;
    }
    strcpy(lookup_name,p->file_name);
    lookup_result = lookup_files_db(lookup_name,fpath,&bsize,&offline);
    if (lookup_result == 1) {
        sprintf(ws,"Found in db: %-12s %-20s %7ld",p->file_name,fpath,bsize);
        if (offline)
            strcat(ws,", OFFLINE");
        strcat(ws,", Skipped.");
        printf("\n%s",ws);
        db_logger(ws);
        FilesSkipped++;
        return;
    }
    original_dta_address = getdta();
    strcat(mask,".*");
    not_found = _dos_findfirst(mask,_A_NORMAL,&ffblk);
    setdta(original_dta_address);
    if (not_found) {
        if (bbs_out != NULL)
            write_file_desc(p->file_name,bbs_out);
        CopyFile(p,workdir);
        return;
    }
    sprintf(ws,"%-12s is already in %s",p->file_name,mrg_dest_dir);
    db_logger(ws);
MergeExit:
    printf("\nSkipped: %s",p->file_name);
    FilesSkipped++;
}

void MergeDirectories(void)
{
    struct find_t ffblk;
    FILE *bbs_out;
    char bbs_out_name[128];
    char mask[128];
    long elapsed_seconds;
    unsigned done;
    struct fnam *p;

    db_log_open  = 0;
    FilesMerged  = 0;
    FilesSkipped = 0;
    FilesTotal   = 0;
    BytesMerged  = 0L;
    MergeStart   = time(NULL);
    strcpy(mrg_work_dir,mrg_dest_dir);
    strcat(mrg_work_dir,"$WORK$");
    printf("\nCreating work directory: %s\n",mrg_work_dir);
    mkdir(mrg_work_dir);
    process_pathname(mrg_work_dir);
    strcpy(bbs_out_name,mrg_work_dir);
    strcat(bbs_out_name,"FILES.TMP");
    strcpy(mask,mrg_src_dir);
    strcat(mask,"*.*");
    done = _dos_findfirst(mask,_A_NORMAL,&ffblk);
    while (!done) {
        add_fnam_table(ffblk.name);
        FilesTotal++;
        done = _dos_findnext(&ffblk);
    }
    load_file_desc();
    p = fnam_root;
    if (p != NULL)
        bbs_out = fopen(bbs_out_name,"wt");
    while (p != NULL) {
        MergeFile(p,mrg_work_dir,bbs_out);
        p = p->next_fnam;
    }
    fclose(bbs_out);
    init_fnam_table();
    init_fn_table();
    if (FilesMerged) {
        MergeFin = time(NULL);
        elapsed_seconds = MergeFin - MergeStart;
        printf("\n\n  %8d  Files Merged",FilesMerged);
        printf(  "\n  %8d  Files Skipped",FilesSkipped);
        printf(  "\n %9ld  Bytes Merged",BytesMerged);
        printf(  "\n    %3ld:%02ld  Elapse Time\n",(elapsed_seconds/60L),(elapsed_seconds%60L));
    }
    close_db_log();
    printf("\007\007");
    return;
}

void MoveFilesUp(void)
{
    struct find_t ffblk;
    char new_path[128];
    char old_path[128];
    char new_fname[128];
    char old_fname[128];
    int cnt;
    unsigned done;

    _fullpath(new_path,"..",126);
    process_pathname(new_path);
    printf("\n\nNew Directory: %s",new_path);
    _fullpath(old_path,".", 126);
    process_pathname(old_path);
    printf(  "\nOld Directory: %s\n",old_path);
    cnt = 0;
    done = _dos_findfirst("*.*",_A_NORMAL,&ffblk);
    while (!done) {
        strcpy(old_fname,old_path);
        strcat(old_fname,ffblk.name);
        strcpy(new_fname,new_path);
        strcat(new_fname,ffblk.name);
        if (!rename(old_fname,new_fname)) {
            printf("\n  <- %s",ffblk.name);
            cnt++;
        }
        done = _dos_findnext(&ffblk);
    }
    printf("\n\n  %d  Files Moved.\n",cnt);
}

static char previous_fname[128];
static char previous_fpath[128];

void write_biglist(FILE *text_out,char *s)
{
    char *fname;
    char *fsize;
    char *fdate;
    char *fdesc;
    char *fpath;
    int j, k, marker;

    fname = &s[0];
    j = pos(" ",fname);
    if (j <= 0)
        return;
    fname[j++] = 0;

    fsize = &fname[j];
    j = pos(" ",fsize);
    if (j <= 0)
        return;
    fsize[j++] = 0;

    fdate = &fsize[j];
    j = pos(" ",fdate);
    if (j <= 0)
        return;
    fdate[j++] = 0;

    fdesc = &fdate[j];
    fpath = "";
    k = strlen(fdesc);
    while (--k > 0) {
        if (fdesc[k] == ' ') {
            fdesc[k++] = 0;
            fpath = &fdesc[k];
            break;
        }
    }
    marker = ' ';
    if (previous_fpath[0]) {
        if (strcmp(previous_fpath,fpath)) {
            for (j=0; j<5; j++) {
                if (fname[j] != previous_fname[j])
                    goto NotEqual;
                if (fname[j] == '.')
                    break;
            }
            marker = '*';
        }
    }
NotEqual:
    strncpy(previous_fname,fname,126);
    previous_fname[127] = 0;
    strncpy(previous_fpath,fpath,126);
    previous_fpath[127] = 0;

    fprintf(text_out,"%c %-12s %8s %6s %-50s %s\n",
        marker,fname,fsize,fdate,fdesc,fpath);
}

void main(int argc,char *argv[])
{
    FILE *allfiles;
    char filename_inp[128], filename_tmp[128], filename_bak[128];
    char drive[16], dir[128], name[80], ext[80], cnf_fname[128];
    char biglist_fname[128];
    char *ep;
    FILE *text;
    FILE *text_out;
    struct fdir *cp;
    char mask[128], cwd[128], ws[528];
    unsigned done, gtdir_flag;
    struct find_t ffblk;
    int k, j, mrg_field_no, ramt;

    for (k=0; k<82; k++)
        tab_stop[k] = 0;
    for (k=8; k<82; k+=8)
        tab_stop[k] = 1;
    getcwd(cwd,120);
    strcpy(dir,&cwd[2]);
    strcat(dir,"\\");
    drive[0] = cwd[0];
    drive[1] = cwd[1];
    drive[2] = 0;
    strcpy(mask,"FILES.BBS");
    directory_merge  = 0;
    gtdir_flag       = 0;
    big_sort         = 0;
    mrg_field_no     = 0;
    for (k=1; k<argc; k++) {
        strcpy(ws,argv[k]);
        strupr(ws);
        switch (ws[0]) {
        case '/':
        case '-':
            if (ws[1] == 'D') {
                printf("\nSizeof user_record = %d\n",sizeof(USER_RECORD));
                exit(0);
            }
            if (ws[1] == 'A') {
                big_sort = 1;
                lgth_date_fmt = 1;
            }
            if (ws[1] == 'F') {
                lgth_date_fmt = 1;
                if (ws[2] == 'V')
                    verify_exists = 1;
            }
            if (ws[1] == 'M') {
                printf("\nDirectory Merge Selected.\n");
                mrg_field_no = 1;
                directory_merge = 1;
                if (ws[2] == 'D')
                    unlink_after_cpy = 1;
                strcpy(mrg_src_dir,cwd);
                process_pathname(mrg_src_dir);
            }
            if (ws[1] == 'U') {
                MoveFilesUp();
                exit(0);
            }
            goto ArgLoop;
        case '@':
            if (!gtdir_flag) {
                load_gtdir(ws);
                gtdir_flag = 1;
            }
            goto ArgLoop;
        default:
            if (directory_merge) {
                if (mrg_field_no == 1) {
                    _fullpath(mrg_dest_dir,ws,126);
                    process_pathname(mrg_dest_dir);
                }
                if (mrg_field_no == 2) {
                    _fullpath(mrg_src_dir,ws,126);
                    process_pathname(mrg_src_dir);
                }
                if (mrg_field_no == 3) {
                    _fullpath(mrg_src_bbs,ws,126);
                    process_pathname(mrg_src_bbs);
                }
                mrg_field_no++;
                goto ArgLoop;
            }
            if (!gtdir_flag) {
                strcpy(mask,ws);
                j = pos("*",mask);
                if (j < 0)
                    j = pos("?",mask);
                if (j < 0) {
                    _fullpath(filename_inp,mask,126);
                    _splitpath(filename_inp,drive,dir,name,ext);
                }
                else {
                    if ((ws[1]==':')&&(ws[0]>='A')&&(ws[0]<='Z')) {
                        drive[0] = ws[0];
                        delete_ch(ws,1,2);
                    }
                    extract_path(dir,ws);
                }
            }
            goto ArgLoop;
        }
ArgLoop:
        ;
    }
    if ((ep = getenv("GTPATH")) != NULL)
	strcpy(gtpath,ep);
    else
	strcpy(gtpath,cwd);
    process_pathname(gtpath);
    strcpy(bbs_path,gtpath);
    strcpy(lan_path,gtpath);
    sprintf(cnf_fname,"%sGT.CNF",gtpath);
    if ((text = fopen(cnf_fname,"rt")) != NULL) {
	do {
	    if ((ramt = fgets_p(ws,512,text)) > 0) {
		strupr(ws);
		if ((ws[2] == '=')&&(ws[3] >= 'A')&&(ws[3] <= 'Z')) {
		    if ((ws[0] == 'B') && (ws[1] == 'B')) {
			strcpy(bbs_path,&ws[3]);
			process_pathname(bbs_path);
			continue;
		    }
		    if ((ws[0] == 'L') && (ws[1] == 'R')) {
			strcpy(lan_path,&ws[3]);
			process_pathname(lan_path);
		    }
		}
	    }
	} while (ramt >= 0);
	fclose(text);
    }
    if (directory_merge) {
        gtdir_flag = 0;
        strcpy(dir,mrg_dest_dir);
        if (dir[1] == ':') {
            delete_ch(dir,1,2);
            drive[0] = mrg_dest_dir[0];
            drive[1] = mrg_dest_dir[1];
            drive[2] = 0;
        }
        if (!mrg_src_dir[0]) {
            strcpy(mrg_src_dir,cwd);
            process_pathname(mrg_src_dir);
        }
        if (!mrg_src_bbs[0]) {
            strcpy(mrg_src_bbs,mrg_src_dir);
            strcat(mrg_src_bbs,"FILES.BBS");
        }
        MergeDirectories();
        chg_dir(mrg_work_dir);
        exit(0);
    }
    if (gtdir_flag) {
        allfiles = NULL;
        if (big_sort) {
            strcpy(biglist_fname,gtpath);
            strcat(biglist_fname,"BIGLIST.DAT");
            allfiles = fopen(biglist_fname,"wt");
        }
        cp = first_fd;
        while (cp != NULL) {
            strcpy(filename_inp,cp->fd_bbs);
            strcpy(cwd,cp->fd_path);
            _splitpath(filename_inp,drive,dir,name,ext);
            _makepath(filename_tmp,drive,dir,name,".$$$");
            _makepath(filename_bak,drive,dir,name,".BAK");
            process_files_bbs(filename_inp,filename_tmp,filename_bak,cwd,allfiles);
            cp = cp->next_fd;
        }
        init_fd_table();
        if (allfiles != NULL) {
            fclose(allfiles);
            chg_dir(gtpath);
            sprintf(ws,"pdsort  biglist.dat  biglist.$$$  %d  1-12:a",biggest_record);
            printf("\n\nEXECUTING:  %s\n\n",ws);
            system(ws);
            unlink("BIGLIST.DAT");
            text = fopen("BIGLIST.$$$","rt");
            if (text == NULL)
                exit(0);
            text_out = fopen("BIGLIST.BBS","wt");
            if (text_out == NULL) {
                fclose(text);
                printf("\n**ERROR: cannot create BIGLIST.BBS\n");
                exit(0);
            }
            printf("\nProducing formatted output: BIGLIST.BBS...");
            previous_fname[0] = 0;
            previous_fpath[0] = 0;
            while ((ramt = fgets_p(ws,512,text)) >= 0) {
                if (ramt > 0)
                    write_biglist(text_out,ws);
            }
            printf("\n\nDONE!\n");
            fclose(text);
            fclose(text_out);
            unlink("BIGLIST.$$$");
        }
        exit(0);
    }
    done = _dos_findfirst(mask,_A_NORMAL,&ffblk);
    while (!done) {
        add_bbs_name(ffblk.name);
        done = _dos_findnext(&ffblk);
    }
    process_pathname(cwd);
    bbs_list_curr = bbs_list_root;
    while (bbs_list_curr != NULL) {
        strcpy(name,bbs_list_curr->bbs_name);
        bbs_list_curr = bbs_list_curr->next_bbs_name;
        strcpy(filename_inp,drive);
        strcat(filename_inp,dir);
        strcat(filename_inp,name);
        _splitpath(filename_inp,drive,dir,name,ext);
        _makepath(filename_tmp,drive,dir,name,".$$$");
        _makepath(filename_bak,drive,dir,name,".BAK");
        process_files_bbs(filename_inp,filename_tmp,filename_bak,cwd,NULL);
    }
}

